/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_DM2LONGREFLINE_H
#define DPC_IMPL_TYPE_DM2LONGREFLINE_H

#include <cfloat>
#include <cmath>

namespace dpc {
struct DM2LongRefLine {
    float ba_ref_line_c0{ 0.0F };
    float ba_ref_line_c1{ 0.0F };
    float ba_ref_line_c2{ 0.0F };
    float ba_ref_line_c3{ 0.0F };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(ba_ref_line_c0);
        fun(ba_ref_line_c1);
        fun(ba_ref_line_c2);
        fun(ba_ref_line_c3);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(ba_ref_line_c0);
        fun(ba_ref_line_c1);
        fun(ba_ref_line_c2);
        fun(ba_ref_line_c3);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("ba_ref_line_c0", ba_ref_line_c0);
        fun("ba_ref_line_c1", ba_ref_line_c1);
        fun("ba_ref_line_c2", ba_ref_line_c2);
        fun("ba_ref_line_c3", ba_ref_line_c3);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("ba_ref_line_c0", ba_ref_line_c0);
        fun("ba_ref_line_c1", ba_ref_line_c1);
        fun("ba_ref_line_c2", ba_ref_line_c2);
        fun("ba_ref_line_c3", ba_ref_line_c3);
    }

    friend bool operator==(const ::dpc::DM2LongRefLine& lhs, const ::dpc::DM2LongRefLine& rhs) noexcept
    {
        return (fabs(static_cast<double>(lhs.ba_ref_line_c0 - rhs.ba_ref_line_c0)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_ref_line_c1 - rhs.ba_ref_line_c1)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_ref_line_c2 - rhs.ba_ref_line_c2)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ba_ref_line_c3 - rhs.ba_ref_line_c3)) < DBL_EPSILON);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_DM2LONGREFLINE_H
